/* 
 * RESDIR: Search and replace strings in a GEM resource file.
 * Copyright (C) 2002 John Elliott <jce@seasip.demon.co.uk>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <sys.h>
#include "ppdgem.h"
#include "tamper.h"


char gemapps[256];
char gemsys[256];
char buf[518];

int main(int argc, char **argv)
{
	unsigned n;
	char *s;
	WORD w;
	union REGS rg;
	struct SREGS sg;

	rg.x.ax = 0x1900;
	intdos(&rg, &rg);

	sprintf(gemsys, "C:\\");
	rg.x.ax = 0x4700;
	rg.x.dx = 0x00;
	rg.x.si = FP_OFF(gemsys+3);
	sg.ds   = FP_SEG(gemsys+3);
	intdosx(&rg, &rg, &sg);

	strcpy(gemapps, gemsys);

	if (argc < 3)
	{
		fprintf(stderr, "Syntax: resdir <gem.rs0> <gem.rsc>");
		return 1;
	}

	s = strrchr(gemapps, '\\');
	if (!s) s = strrchr(gemapps, '/');
	if (s) *s = 0;

	w = load_rsc(argv[1]);
	if (w) return w;

	for (n = 0; n < string_count(); n++)
	{
		char *old = get_string(n);
		int change = 0;

/* Check for GEM.RSC paths and replace them. */
		if (!strcmp(old, "C:\\GEMAPPS\\GEMSYS;C:\\GEMAPPS;C:\\"))
		{
			strcpy(buf, gemsys);
			strcat(buf, ";");
			strcat(buf, gemapps);
			strcat(buf, ";C:\\");
			change  = 1;
		}	
		else if (strstr(old, "C:\\GEMAPPS\\GEMSYS"))
		{
			strcpy(buf, gemsys);
			strcat(buf, old + strlen("C:\\GEMAPPS\\GEMSYS"));
			change  = 1;
		}
		else if (strstr(old, "C:\\GEMAPPS"))
		{
			strcpy(buf, gemapps);
			strcat(buf, old + strlen("C:\\GEMAPPS"));
			change  = 1;
		}
		if (change) put_string(n, buf);
	}
	return save_rsc(argv[2]);
}
